---------------------------------------------------------------
-- HalfAdder-component in the SanGregory99 Leading one detector submodule
---------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

---------------------------------------------------------------
-- Defining the entity
---------------------------------------------------------------

entity half_adder is
port(
   A   : in std_logic;
   B   : in std_logic;
   S   : out std_logic;
   C_out: out std_logic);
end half_adder;

---------------------------------------------------------------
-- Architecture
---------------------------------------------------------------

architecture behavioral of half_adder is

begin
    
-- Simple combinatoral half-adder process    
    process(A , B)
    begin
        S     <= A XOR B;
        C_out <= A AND B;
   end process;
end architecture behavioral;